/* $VER: FontSpec.rexx 1.0 (07.02.94)
   Copyright 1994 Soft-Logik Publishing Corporation
   May not be distributed without Soft-Logik Publishing Corporation's express written permission */

OPTIONS RESULTS
TRACE OFF

/* Make sure rexx support is opened */
IF ~SHOW('L','rexxsupport.library') THEN
   CALL ADDLIB('rexxsupport.library',0,-30)

ADDRESS 'PAGESTREAM'

/* Give Instructions */
allocarexxrequester '"Create Font Specimen Sheets"' 592 111
    reqhandle=result
addarexxgadget reqhandle EXIT 12 94 70 label "_Ok"
    Okhandle=result
addarexxgadget reqhandle EXIT 510 94 70 label "_Cancel"
    Cancelhandle=result
addarexxgadget reqhandle TEXT 8 10 576 border none string "'This macro will print a font specimen sheet for each font installed'"
addarexxgadget reqhandle TEXT 8 20 576 border none string "'with the Font Preferences requester. Font specimen sheets are useful'"
addarexxgadget reqhandle TEXT 8 30 576 border none string "'for selecting fonts to use. Before using this macro, you should add the'"
addarexxgadget reqhandle TEXT 8 40 576 border none string "'font directories you want specimen sheets for to the Font Preferences'"
addarexxgadget reqhandle TEXT 8 50 576 border none string "'requester, and remove the font directories which you do not want sheets'"
addarexxgadget reqhandle TEXT 8 60 576 border none string "'for. Turn you printer on before continuing. Note: printing a page for'"
addarexxgadget reqhandle TEXT 8 70 576 border none string "'each font can take a long time.'"
doarexxrequester reqhandle

action=result
freearexxrequester reqhandle
if action~=okhandle then EXIT

/* Make the font spec document */
'NEWDOCUMENT FontSpec '
'SETDOCUMENTDESC "" '
'NEWMASTERPAGE "Default Master Page" 8.5i 11i PORTRAIT SINGLE '
'SETMASTERPAGEDESC "" '
'SETDIMENSIONS 8.5i 11i PORTRAIT SINGLE '
'SETBLEED 0i 0i '
'SETMARGINGUIDES 0.5i 0.5i 1i 1i '
'SETCOLUMNGUIDES 1 0.25i '
'SETDOCUMENTSTATUS UNCHANGED '
'OPENWINDOW View.1 PAGE 1 '

openbusyrequester message "'Preparing FontSpec document...'" thermometer enabled abort enabled total 100 current 0
bh=result

/* Draw the surrounding box */
'drawbox 0.5i 1i 8i 10i'

/* Make the style tag */
'newstyletag "FontSample" character'

/* Make the title */
'settoolmode text'
'drawtextobj 0.75i 1.25i'
thandle=result
'selecttext at 0.75i 1.25i'
'settypesize 36pt'
'setfont Triumvirate'
'settypestyle Bold'
'insert "Font Name"'

call setbusy(5)

sizes.1=10
sizes.2=12
sizes.3=15
sizes.4=18
sizes.5=24
sizes.6=36
sizes.7=48

/* Make the text frames */
'drawcolumn 0.75i 2i 1.25i 4.75i columns 1 gutter 0'
sfhandle=result
'selecttext at 0.75i 2i'
'settypesize 10pt'
do i=1 to 7
    'setleading fixed 'sizes.i+2'pt'
    'insert 'sizes.i'pt'
    'insertcontrol newparagraph'
    call setbusy(5+4*i)
end i

'drawcolumn 1.25i 2i 7.75i 4.75i columns 1 gutter 0'
tfhandle=result
'selecttext at 1.25i 2i'
'setcharacterstyle "FontSample"'
do i=1 to 7
    'setleading fixed 'sizes.i+2'pt'
    'settypesize 'sizes.i'pt'
    'insert "The Quick Brown Fox"'
    'insertcontrol newparagraph'
    call setbusy(33+4*i)
end i

'drawtextobj 0.75i 5i'
'selecttext at 0.75i 5i'
'settypesize 18pt'
'setfont Triumvirate'
'settypestyle Bold'
'insert "Character Set Sample"'

call setbusy(66)

'drawcolumn 0.75i 5.5i 7.75i 7.25i columns 1 gutter 0'
mfhandle=result
'selecttext at 0.75i 5.5i'
'setcharacterstyle "FontSample"'
'settypesize 24pt'
'insert abcdefghijklmnopqrstuvwxyz'
call setbusy(69)
'insertcontrol newparagraph'
'insert ABCDEFGHIJKLMNOPQRSTUVWXYZ'
call setbusy(72)
'insertcontrol newparagraph'
'insert 1234567890!@#$%^&*<?>'
call setbusy(75)


'drawtextobj 0.75i 7.5i'
'selecttext at 0.75i 7.5i'
'settypesize 18pt'
'setfont Triumvirate'
'settypestyle Bold'
'insert "Body Text Sample"'

call setbusy(80)

'drawcolumn 0.75i 8i 7.75i 9.75i columns 1 gutter 0'
bfhandle=result
'selecttext at 0.75i 8i'
'setcharacterstyle "FontSample"'
'settypesize 12pt'
'setleading fixed 14pt'
'insert "It was the best of times, it was the worst of times, it was the age of wisdom, it was the age of foolishness, it was the epoch of belief, it was the epoch of"'
call setbusy(87)
'insert " incredulity, it was the season of Light, it was the season of Darkness, it was the spring of hope, it was the winter of despair, we had everything before us,"'
call setbusy(94)
'insert " we had nothing before us, we were all going direct to Heaven, we were all going direct the other way."'
call setbusy(100)
closebusyrequester bh

/* Get the names and number of faces */
getfontfamilies faces
facecount=result

/* Count Fonts */
fontcount=0
do i=0 to facecount-1
    getfontstyles faces.i styles
    stylecount=result

    /* Repeat for each style */
    do ii=0 to stylecount-1
        fontcount=fontcount+1
    end ii
end i


/* MAIN LOOP */
openbusyrequester message "'Creating Font Samples...'" thermometer enabled abort enabled total fontcount current 0
bh=result
printcount=0
do i=0 to facecount-1
    getfontstyles faces.i styles
    stylecount=result

    /* Repeat for each style */
    do ii=0 to stylecount-1
        printcount=printcount+1

        /* Change the title */
        'selecttext at 0.75i 1.25i'
        'selecttext all'
        'insert "'faces.i'-'styles.ii'"'

        /* Change the font and style */
        'refresh wait'
        'clearstyletag FontSample'
        'setfont 'faces.i' styletag FontSample'
        'settypestyle 'styles.ii' styletag FontSample'
        'refresh continue'

        /* Print the font sample page */
        call setbusy(printcount)
        'printdocument copies 1 page 1 sides both scale actual output grayscale printermarks off mirror off negative off'
    end ii
end i
call cleanup()
EXIT


SETBUSY:
    parse arg value
    ADDRESS PAGESTREAM
    setbusyrequester bh current value
    getbusyrequester bh
    if result=1 then call CLEANUP(1)
    ADDRESS COMMAND
RETURN

CLEANUP:
    closebusyrequester bh
    'closedocument force'
EXIT
